;########################################################
;# Tat's Reflector. Reflects dcc sends to other places  #
;# This is done by intercepting the ctcp message and    #
;# making a fake dcc send to another location replacing #
;# all the information with the other given information #
;# in this way party 2 expects a send from you, while   #
;# party 1 expects to send to you. You lie to them both #
;# and tell each that you are the other party. They     #
;# think you are sending and recieving the file. Which  #
;# isn't true.                                          #
;########################################################
raw 401:*:{
  if ($2 == %reflector.forward) {
    echo -s $rc1 $+ User %reflector.forward not found on this network, trying others.
    halt
  }
}
ctcp *:DCC*:*:{
  echo -s $rc1 $+ $1-
  if (!%reflector.on) { return }
  if ($2 == SEND) {
    if (($4 == $longip($ip)) && ($nick != $me)) {
      logdcc $rc1 $+ File: $rc2 $+ $3 $rc1 $+ was dropped, because incomming send from $rc2 $+ $nick $rc1 $+ originated from this machine.
      haltdef
    }
    if ($reflect($nick)) {
      logdcc $rc1 $+ Reflecting: $rc2 $+ $3 $rc1 $+ from $rc2 $+ $nick $+ $rc1 to $rc2 $+ $iif(%reflector.forward, %reflector.forward, $nick) $+ $rc1 $+ .
      set -u120 %reflected.last $nick
      pvmsg $iif(%reflector.forward != $null, %reflector.forward, $nick) $chr(1) $+ $1-2 $reflector.random($3) $4- $+ $chr(1)
      haltdef
    }
    else { logdcc $rc1 $+ Incomming Get: $rc2 $+ $filename $rc1 $+ from $rc2 $+ $nick }
  }
  if (($2 == CHAT) && (%reflector.chat)) {
    logdcc $rc1 $+ Fserver/Chat Reflect: $rc2 $+ $3 $rc1 $+ from $rc2 $+ $nick $+ $rc1 to $rc2 $+ %nick.send $+ $rc1 $+ .
    pvmsg $iif(%reflector.forward != $null, %reflector.forward, $nick) $chr(1) $+ $1- $+ $chr(1)
    haltdef
  }
  if (($2 == RESUME) && ($nick == %reflector.forward)) {
    logdcc $rc1 $+ $nick resuming file through reflector.
    if (%reflected.last != $null) pvmsg %reflected.last $chr(1) $+ $1- $+ $chr(1)
    haltdef
  }
  if (($2 == ACCEPT) && ($nick == %reflected.last)) {
    logdcc $rc1 $+ $nick accepted file through reflector.
    if (%reflector.forward != $null) pvmsg %reflector.forward $chr(1) $+ $1- $+ $chr(1)
    haltdef
  }
}
alias -l reflector.random { return $iif(%reflector.random, $rand(A,Z) $+ $rand(a,z) $+ $rand(a,z) $+ $rand(a,z) $+ $rand(a,z) $+ $rand(0,9) $+ . $+ $gettok($3, $numtok($3, $asc(.)), $asc(.)), $1-) }
alias pvmsg {
  if ((%reflector.network) && ($version >= 6) && ($scid(0) > 1)) {
    scid -at1 echo Dcc Reflect on all network connections. Do not be alarmed if the user isn't on this specific network.
    scid -at1 privmsg $1-
  }
  else {
    echo -s -> $1-
    privmsg $1-
  }
}
alias rget { return $readini(reflector.ini, $1, $2) }
alias rset {
  if ($3) { writeini reflector.ini $1- }
  elseif ($1) { remini reflector.ini $1- }
}
alias reflect {
  if (%reflector.all) { return $true }
  var %i = 1
  while ($rget(refuser, %i)) {
    if ($rget(refuser, %i) == $1) { return $true }
    inc %i
  }
}
alias r.add { rset refuser $calc($ini(reflector.ini, refuser, 0) + 1) $1 }
alias r.clear { rset refuser }
alias r.del {
  if ($1 !isnum) { return }
  var %i = $1
  while ($rget(refuser,$calc(%i + 1))) {
    rset refuser %i $rget(refuser, $calc(%i + 1))
    inc %i
  }
  rset refuser %i
}
on *:GETFAIL:*:{ logdcc $rc1 $+ Failed to recieve $rc2 $+ $nopath($filename) $rc1 $+ from $rc2 $+ $nick $+ $rc1 $+ . IP: $rc2 $+ $get($nick).ip $+ $rc1 Size: $+ $rc2 $get($nick).size $+ $rc1 $+ . Done: $rc2 $+ $round($calc($get($nick).rcvd * 100 / $get($nick).size),2) $+ $rc1 $+ % $+ . }
on *:FILERCVD:*: { logdcc $rc1 $+ Recieved: $rc2 $+ $nopath($filename) $rc1 $+ from $+ $rc2 $nick $+ $rc1 at $+ $rc2 $bytes($get($nick).cps,k).suf $+ $rc1 $+ /s. IP: $rc2 $+ $get($nick).ip }
on *:FILESENT:*: { logdcc $rc1 $+ Sent: $rc2 $+ $nopath($filename) $rc1 $+ to $+ $rc2 $nick $+ $rc1 at $+ $rc2 $bytes($send($nick).cps,k).suf $+ $rc1 $+ /s. IP: $rc2 $+ $send($nick).ip }
on *:SENDFAIL:*: { logdcc $rc1 $+ Failed to send: $rc2 $+ $nopath($filename) $rc1 $+ to $+ $rc2 $nick $+ $rc1 $+ . IP: $rc2 $+ $send($nick).ip $rc1 $+ Size: $rc2 $+ $send($nick).size $rc1 $+ Done: $rc2 $+ $round($calc($send($nick).sent * 100 / $send($nick).size),2) $+ $rc1 $+ % $+ . }
dialog reflectset {
  title Reflector $+ $chr(44) v $+ $reflector.version by Tat
  size -1 -1 335 230
  button Ok, 100, 265 210 60 20, ok
  list 101, 55 100 200 100
  button Delete, 102, 265 110 60 20
  button Add, 103, 265 140 60 20
  button Clear, 104, 265 170 60 20
  check Reflector, 120, 10 10 90 20
  check Reflect All, 130, 110 10 90 20
  check Reflect Fserve, 140, 210 10 90 20
  check Random Name, 150, 110 30 90 20
  check Multi-network, 160, 210 30 90 20
  check Log Activity, 170, 10 30 90 20
  text "Forward To:", 20, 10 50 70 20
  edit [ %reflector.forward ], 30, 75 50 150 20
  text "Blank, returns to sender", 40, 75 70 140 20
}
on *:dialog:reflectset:edit:30:{ %reflector.forward = $did($did) }
on *:dialog:reflectset:sclick:130:{ %reflector.all = $did($did).state }
on *:dialog:reflectset:sclick:140:{ %reflector.chat = $did($did).state }
on *:dialog:reflectset:sclick:150:{ %reflector.random = $did($did).state }
on *:dialog:reflectset:sclick:160:{ %reflector.network = $did($did).state }
on *:dialog:reflectset:sclick:170:{ %reflector.log = $did($did).state }
on *:dialog:reflectset:sclick:120:{
  %reflector.on = $did(120).state
  did - $+ $iif($did(120).state,e,b) reflectset 30,101,102,103,104,130,140,150,160
}
on *:dialog:reflectset:sclick:102:{
  r.del $$did(101).sel
  reflector.load
}
on *:dialog:reflectset:sclick:103:{
  r.add $$?="Reflect from whom"
  reflector.load
}
on *:dialog:reflectset:sclick:104:{
  r.clear
  reflector.load
}
alias reflector.load {
  did -r $dname 101
  var %i = 1
  while ($rget(refuser,%i)) {
    did -a $dname 101 $rget(refuser,%i)
    inc %i
  }
}
on *:dialog:reflectset:init:*:{
  if (%reflector.on) { did -c reflectset 120 }
  else { did -b reflectset 30,101,102,103,104,130,140,150,160 }
  if (%reflector.all) { did -c reflectset 130 }
  if (%reflector.chat) { did -c reflectset 140 }
  if (%reflector.random) { did -c reflectset 150 }
  if (%reflector.network) { did -c reflectset 160 }
  if (%reflector.log) { did -c reflectset 170 }
  reflector.load
}
menu menubar {
  -
  Reflector:if (!$dialog(reflectset)) { dialog -m reflectset reflectset }
  -
}
menu nicklist {
  -
  Forward to:%reflector.forward = $$1
  Reflect from: r.add $$1
  -
}
alias rput {
  if ($3) { writeini reflector.ini $1 $2 $3- }
  else { removeini reflector.ini $1- }
}
alias rget { return $readini(reflector.ini,$1,$2) }
alias rc1 { return 04 }
alias rc2 { return 03 }
alias logdcc {
  if (%reflector.log) {
    if (!$window(@DCC)) { window -enz @DCC }
    aline @DCC $date $time $1-
  }
  echo -s $1-
}
alias reflector.version { return 1.92 }
